unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Psock, NMHttp;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    Memo4: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    OpenDialog1: TOpenDialog;
    NMHTTP1: TNMHTTP;
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure NMHTTP1AuthenticationNeeded(Sender: TObject);
    procedure NMHTTP1Failure(Cmd: CmdType);
    procedure NMHTTP1Success(Cmd: CmdType);
    procedure NMHTTP1Redirect(var Handled: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button4Click(Sender: TObject);
//Trace
var
  S1: String;
begin
  if InputQuery('', '    ',S1) then
      NMHTTP1.Trace(Edit1.Text, S1);
end;

procedure TForm1.Button5Click(Sender: TObject);
//Put
begin
  if OpenDialog1.Execute then
  begin
    NMHTTP1.OutputFileMode := true;
    NMHTTP1.Put(Edit1.Text,OpenDialog1.FileName);
    NMHTTP1.OutputFileMode := False;
  end;
end;

procedure TForm1.Button6Click(Sender: TObject);
//Post
var
  S1: String;
begin
  if InputQuery('     Web', '  ', S1) then
    NMHTTP1.Post(Edit1.Text, S1);
end;

procedure TForm1.Button1Click(Sender: TObject);
//Get
begin
  NMHTTP1.Get(Edit1.Text);
end;

procedure TForm1.Button2Click(Sender: TObject);
//Head
begin
  NMHTTP1.Head(Edit1.Text);
end;

procedure TForm1.Button3Click(Sender: TObject);
//Options
begin
  NMHTTP1.Options(Edit1.Text);
end;

procedure TForm1.Button7Click(Sender: TObject);
//Delete
begin
  NMHTTP1.Delete(Edit1.Text);
end;

procedure TForm1.NMHTTP1AuthenticationNeeded(Sender: TObject);
var
  AnID,
  APass:   String;
begin
  InputQuery('  ', '  ', AnID);
  InputQuery('  ', ' ', APass);
  NMHTTP1.HeaderInfo.UserID := AnID;
  NMHTTP1.HeaderInfo.Password := APass;
  ShowMessage('   , ,   ');
end;

procedure TForm1.NMHTTP1Failure(Cmd: CmdType);
begin
  Memo1.Text := NMHTTP1.Header;
  Memo2.Text := NMHTTP1.Body;
  case Cmd of
   CmdGET: Memo3.Lines.Add('  GET');
   CmdPOST: Memo3.Lines.Add('  Post');
   CmdHEAD: Memo3.Lines.Add('  HEAD');
   CmdOPTIONS: Memo3.Lines.Add('  OPTIONS');
   CmdTrace: Memo3.Lines.Add('  TRACE');
   CmdPut: Memo3.Lines.Add('  PUT');
   CmdDelete: Memo3.Lines.Add('  Delete');
   end;
end;

procedure TForm1.NMHTTP1Success(Cmd: CmdType);
begin
  if NMHTTP1.CookieIn <> '' then
     Memo4.Text := NMHTTP1.CookieIn;
     Case Cmd of
       CmdGET:
           begin
             Memo1.Text := NMHTTP1.Header;
             Memo2.Text := NMHTTP1.Body;
             Memo3.Lines.Add(' GET  ');
           end;
       CmdPOST:
           begin
            Memo1.Text := NMHTTP1.Header;
            Memo2.Text := NMHTTP1.Body;
            Memo3.Lines.Add(' POST  ');
           end;
       CmdHEAD:
           begin
            Memo1.Text := NMHTTP1.Header;
            Memo2.Text := NMHTTP1.Body;
            Memo3.Lines.Add(' HEAD  ');
           end;
        CmdOPTIONS:
           begin
            Memo1.Text := NMHTTP1.Header;
            Memo2.Text := NMHTTP1.Body;
            Memo3.Lines.Add(' OPTIONS  ');
           end;
        CmdTrace:
           begin
            Memo1.Text := NMHTTP1.Header;
            Memo2.Text := NMHTTP1.Body;
            Memo3.Lines.Add(' TRACE  ');
           end;
        CmdPut:
           begin
            Memo1.Text := NMHTTP1.Header;
            Memo2.Text := NMHTTP1.Body;
            Memo3.Lines.Add(' PUT  ');
           end;
        CmdDelete:
           begin
            Memo1.Text := NMHTTP1.Header;
            Memo2.Text := NMHTTP1.Body;
            Memo3.Lines.Add(' DELETE  ');
           end;
        end;
end;

procedure TForm1.NMHTTP1Redirect(var Handled: Boolean);
begin
  If MessageDlg('     .  ?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then
     Handled := true;
end;

end.
